-- Created by Indev for Sunflower's Garden
local function findPlayer(name)
    for player in players.iterate do
        if player.name == name then return player end
    end
end

COM_AddCommand("forceappearance", function(p, targetname, targetskin, targetappearance)
    if not (targetname and targetskin and targetappearance) then
        CONS_Printf(p, "Usage: forceappearance <target> <skin> <appearance>")
        CONS_Printf(p, "Forces given appearance over player if they use given skin")
        CONS_Printf(p, "Use forceappearance <target> <skin> clear to disable effect")
        return
    end

    local target = findPlayer(targetname)

    if not target then
        CONS_Printf(p, "Player "..targetname.." not found")
        return
    end

    local appearrestore = target.appearrestore or {}
    target.appearrestore = appearrestore

    if targetappearance == "clear" then
        if target.appearance then
            target.appearance[targetskin:lower()] = appearrestore[targetskin:lower()]
            return
        end
    end

    local appearexists = APPEAR_Skins[targetskin:lower()] and APPEAR_Skins[targetskin:lower()][targetappearance:lower()]

    if not appearexists then
        CONS_Printf(p, "Appearance "..targetappearance.." for skin "..targetskin.." not found")
        return
    end

    local oldappearance = APPEAR_GetAppearance(target)

    if oldappearance == "default" then oldappearance = nil end

    appearrestore[targetskin:lower()] = oldappearance

    target.appearance = $ or {}
    target.appearance[targetskin:lower()] = targetappearance:lower()

    CONS_Printf(p, "Force appearance "..targetappearance.." for "..targetname.."'s skin "..targetskin)
end, COM_ADMIN)
